#pragma once

#include <functional>
#include <ReferenceCounter.h>

class Model;

class View : public virtual Framework::ReferenceCounter
{

public:
    View();
    virtual ~View();
    virtual void update( Model *m ) = 0;
};

class ActionView : public View
{
private:
    std::function< void( Model * ) > f;

public:
    ActionView( std::function< void( Model * ) > f );
    void update( Model *m ) override;
};